class Encoder(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  filterbank : __torch__.asteroid_filterbanks.free_fb.FreeFB
  def forward(self: __torch__.asteroid_filterbanks.enc_dec.Encoder,
    argument_1: Tensor) -> Tensor:
    _0 = __torch__.asteroid_filterbanks.enc_dec.multishape_conv1d
    mixture_w = _0(argument_1, self.filterbank._filters, 16, 0, True, )
    return mixture_w
class Decoder(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  filterbank : __torch__.asteroid_filterbanks.free_fb.___torch_mangle_241.FreeFB
  def forward(self: __torch__.asteroid_filterbanks.enc_dec.Decoder,
    argument_1: Tensor) -> Tensor:
    _1 = __torch__.asteroid_filterbanks.enc_dec.multishape_conv_transpose1d
    _2 = _1(argument_1, self.filterbank._filters, 16, 0, 0, )
    return _2
def multishape_conv1d(waveform: Tensor,
    filters: Tensor,
    stride: int,
    padding: int=0,
    as_conv1d: bool=True) -> Tensor:
  _3 = "Input tensor was 2D. Applying the corresponding Decoder to the current output will result in a 3D tensor. This behaviours was introduced to match Conv1D and ConvTranspose1D, please use 3D inputs to avoid it. For example, this can be done with input_tensor.unsqueeze(1)."
  _4 = __torch__.asteroid_filterbanks.enc_dec.batch_packed_1d_conv
  if torch.eq(torch.dim(waveform), 1):
    _6 = torch.unsqueeze(torch.unsqueeze(waveform, 0), 1)
    _7 = torch.conv1d(_6, filters, None, [stride], [padding], [1], 1)
    _5 = torch.squeeze(_7)
  else:
    if torch.eq(torch.dim(waveform), 2):
      torch.warn(_3, 2)
      _9 = torch.conv1d(torch.unsqueeze(waveform, 1), filters, None, [stride], [padding], [1], 1)
      _8 = _9
    else:
      if torch.eq(torch.dim(waveform), 3):
        batch, channels, time_len, = torch.size(waveform)
        if torch.eq(channels, 1):
          _11 = as_conv1d
        else:
          _11 = False
        if _11:
          _13 = torch.conv1d(waveform, filters, None, [stride], [padding], [1], 1)
          _12 = _13
        else:
          _14 = _4(waveform, filters, stride, padding, )
          _12 = _14
        _10 = _12
      else:
        _15 = _4(waveform, filters, stride, padding, )
        _10 = _15
      _8 = _10
    _5 = _8
  return _5
def multishape_conv_transpose1d(spec: Tensor,
    filters: Tensor,
    stride: int=1,
    padding: int=0,
    output_padding: int=0) -> Tensor:
  if torch.eq(torch.dim(spec), 2):
    _17 = torch.conv_transpose1d(torch.unsqueeze(spec, 0), filters, None, [stride], [padding], [output_padding], 1, [1])
    _16 = torch.squeeze(_17)
  else:
    if torch.eq(torch.dim(spec), 3):
      _19 = torch.conv_transpose1d(spec, filters, None, [stride], [padding], [output_padding], 1, [1])
      _18 = _19
    else:
      _20 = torch.slice(torch.size(spec), -2, 9223372036854775807, 1)
      view_as = torch.add([-1], _20)
      out = torch.conv_transpose1d(torch.reshape(spec, view_as), filters, None, [stride], [padding], [output_padding], 1, [1])
      _21 = torch.slice(torch.size(spec), 0, -2, 1)
      _22 = torch.view(out, torch.add(_21, [-1]))
      _18 = _22
    _16 = _18
  return _16
def batch_packed_1d_conv(inp: Tensor,
    filters: Tensor,
    stride: int=1,
    padding: int=0) -> Tensor:
  _23 = torch.view(inp, [-1, 1, (torch.size(inp))[-1]])
  batched_conv = torch.conv1d(_23, filters, None, [stride], [padding], [1], 1)
  _24 = torch.slice(torch.size(inp), 0, -1, 1)
  _25 = torch.slice(torch.size(batched_conv), -2, 9223372036854775807, 1)
  output_shape = torch.add(_24, _25)
  _26 = torch.view(batched_conv, output_shape)
  return _26
